﻿Public Class Form1

    Dim shrtcutopen As Integer = 0, shrtcutclose As Integer = 0
  
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        label1.Font = New System.Drawing.Font(label1.Font.FontFamily, 12, FontStyle.Bold)
    
        Dim Employees As New DataTable()
        Employees.Columns.Add("Employee Code", GetType(Integer))
        Employees.Columns.Add("Name", GetType(String))
        Employees.Columns.Add("Age", GetType(Integer))
        Employees.Columns.Add("Department", GetType(String))
        Employees.Rows.Add(1, "John", 25, "QA")
        Employees.Rows.Add(2, "Joe", 30, "QA")
        Employees.Rows.Add(3, "Victor", 35, "Support")
        Employees.Rows.Add(4, "Rose", 29, "QA")
        Employees.Rows.Add(5, "Samantha", 30, "Support")
        Employees.Rows.Add(6, "Fuller", 40, "Support")
        Employees.Rows.Add(7, "Adam", 32, "QA")
        Employees.Rows.Add(8, "Eric", 37, "Support")
        Employees.Rows.Add(9, "James", 24, "Support")

        Dim EmpCode As New DataTable()
        EmpCode.Columns.Add("Code", GetType(Integer))
        EmpCode.Rows.Add(10)
        EmpCode.Rows.Add(11)
        EmpCode.Rows.Add(13)
        EmpCode.Rows.Add(1)
        EmpCode.Rows.Add(5)
        EmpCode.Rows.Add(8)
        EmpCode.Rows.Add(19)
        EmpCode.Rows.Add(23)

        c1TrueDBGrid1.DataSource = Employees
        c1TrueDBDropdown1.DataSource = EmpCode
        c1TrueDBGrid1.FilterBar = True

        c1TrueDBGrid1.Columns(0).DropDown = c1TrueDBDropdown1

        For i As Integer = 0 To c1TrueDBGrid1.Columns.Count - 1
            c1TrueDBGrid1.Columns(i).FilterDropdown = True
            c1TrueDBGrid1.Columns(i).FilterMultiSelect = True
        Next

        AddHandler c1TrueDBDropdown1.DropDownOpen, AddressOf c1TrueDBDropdown1_DropDownOpen
        AddHandler c1TrueDBDropdown1.DropDownClose, AddressOf c1TrueDBDropdown1_DropDownClose
        c1TrueDBDropdown1.DropdownWidth = C1.Win.C1TrueDBGrid.DropdownWidthEnum.Column
        Me.KeyPreview = True

    End Sub

    Dim ddstate As Integer = 0

    Private Sub c1TrueDBDropdown1_DropDownOpen(sender As Object, e As EventArgs)
        ddstate = 1
        shrtcutopen = 0
        shrtcutclose = 1
    End Sub

    Private Sub c1TrueDBDropdown1_DropDownClose(sender As Object, e As EventArgs)
        ddstate = 0
        shrtcutclose = 0
    End Sub

    Dim filter As Integer = 0
 
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, keyData As Keys) As Boolean
        If keyData = (Keys.Shift Or Keys.F1) Then            'Shortcut key to be used

            If ddstate = 0 Then
                shrtcutopen = 0
            End If

            'CODE TO OPEN THE DROPDOWNS IN THE GRID CELLS WITH SHORTCUT KEY {SHIFT+F1}
             If shrtcutopen = 0 Then
                SendKeys.Send("%{DOWN}")
                shrtcutopen = 1
            End If

         
            'CODE TO OPEN THE DROPDOWNS IN THE FILTERBAR WITH SHORTCUT KEY {SHIFT+F1}

            If filter = 0 Then
               
                If c1TrueDBGrid1.FilterActive Then
                    SendKeys.Send("%{DOWN}")
                    filter = 1
                    shrtcutopen = 0
                End If
            End If
             Return False
        End If
        If keyData = (Keys.Shift Or Keys.F2) Then
            'Shortcut key to be used
            'CODE TO CLOSE THE DROPDOWNS IN THE GRID CELLS WITH SHORTCUT KEY {SHIFT+F2}

            If shrtcutclose = 1 Then
                SendKeys.Send("%{UP}")
                shrtcutclose = 0
            End If

            'CODE TO CLOSE THE DROPDOWNS IN THE FILTERBAR WITH SHORTCUT KEY {SHIFT+F2}

            If filter = 1 Then
                SendKeys.Send("%{UP}")
                filter = 0
                shrtcutopen = 0
            End If
            Return False
        End If
        If keyData = Keys.Enter Then
            filter = 0
        End If

        Return MyBase.ProcessCmdKey(msg, keyData)
    End Function


    Private Sub c1TrueDBGrid1_FilterButtonClick(sender As System.Object, e As C1.Win.C1TrueDBGrid.ColEventArgs) Handles c1TrueDBGrid1.FilterButtonClick
        filter = 1
    End Sub

    Private Sub c1TrueDBDropdown1_SelChange(sender As System.Object, e As C1.Win.C1TrueDBGrid.CancelEventArgs) Handles c1TrueDBDropdown1.SelChange
        shrtcutopen = 0
     End Sub
End Class
